import _regeneratorRuntime from 'regenerator-runtime';
import fs from 'fs';
import { resolve } from 'path';

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

var viteConfig;
var includeRegexp = /*#__PURE__*/new RegExp(/\.(css|js)$/i);
var excludeRegexp = /*#__PURE__*/new RegExp(/vendor/);
/**
 * 给index.js注入script脚本
 * @param {string} script - 需要执行的脚本字符串
 */

var banner = function banner(script) {
  return {
    name: 'vite-plugin-inject-script',
    configResolved: function configResolved(resolvedConfig) {
      viteConfig = resolvedConfig;
    },
    //@ts-ignore
    writeBundle: function writeBundle(options, bundle) {
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var _i, _Object$entries, file, root, outDir, fileName, filePath, data;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _i = 0, _Object$entries = Object.entries(bundle);

              case 1:
                if (!(_i < _Object$entries.length)) {
                  _context.next = 22;
                  break;
                }

                file = _Object$entries[_i];
                // 获取文件路径
                root = viteConfig.root;
                outDir = viteConfig.build.outDir || 'dist';
                fileName = file[0];
                filePath = resolve(root, outDir, fileName);

                if (fileName.includes('assets/index') && fileName.endsWith('js')) {
                  _context.next = 9;
                  break;
                }

                return _context.abrupt("continue", 19);

              case 9:
                if (!(includeRegexp.test(fileName) && !excludeRegexp.test(fileName))) {
                  _context.next = 19;
                  break;
                }

                _context.prev = 10;
                // 读取文件内容
                data = fs.readFileSync(filePath, {
                  encoding: 'utf8'
                }); // 否则添加注释符

                data = script + ";\n" + data;
                fs.writeFileSync(filePath, data);
                _context.next = 19;
                break;

              case 16:
                _context.prev = 16;
                _context.t0 = _context["catch"](10);
                throw _context.t0;

              case 19:
                _i++;
                _context.next = 1;
                break;

              case 22:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[10, 16]]);
      }))();
    }
  };
};

export default banner;
//# sourceMappingURL=vite-plugin-inject-script.esm.js.map
